#include "uart.h"

#if 1
void print_int(int num)
{
	int i = 0;
	char num_str[6] = {' '};
	if(num > 99999)
		return;
	for(i = 0; i < 5; i++)
	{
		num_str[5-i] = num % 10 + '0';
		num = num / 10;
	}
	print(num_str);
	return;
}

int D_fib(int n)
{
	if(n <= 0)
		return 0;
	else if(n == 1 || n == 2)
		return 1;
	else
	{
		return  D_fib(n-2) + D_fib(n-1);
	}
}

int get_int_lt_100(void)
{
	print("\nPlease input a positive integer less than 26 \npress any key to finish:\n");
	int result = 0;
	int cnt = 0;
	char tmp = '\0';
	char int_str[2] = {'0'};
	for(cnt = 0; cnt < 2; cnt++)
	{
		tmp = getchar();
		if(tmp < '0' || tmp > '9')
		{
			int_str[1-cnt] = '\0';
			break;
		}
		else
		{
			putchar(tmp);
			int_str[1-cnt] = tmp;
		}
	}

	if(int_str[1] == '\0')
		result = 0;
	else if(int_str[0] == '\0')
		result = int_str[1] - '0';
	else
		result = int_str[0] + int_str[1] * 10 - 528;
	return result;
}


int main(void)
{
	reg_uart_clkdiv = 104;
	//reg_uart_clkdiv = 416;
	int seed = 0;
	while(1)
	{
		seed = get_int_lt_100();
		print_int(seed);
		print("\nresult is: \n");
		int fib = D_fib(seed);
		print_int(fib);
	}
	return 0;
}
#endif




#if 0
int main(void)
{

	reg_uart_clkdiv = 104;

	print("Booting..\n");

	print("\n");
	print("  ____  _          ____         ____\n");
	print(" |  _ \\(_) ___ ___/ ___|  ___  / ___|\n");
	print(" | |_) | |/ __/ _ \\___ \\ / _ \\| |\n");
	print(" |  __/| | (_| (_) |__) | (_) | |___\n");
	print(" |_|   |_|\\___\\___/____/ \\___/ \\____|\n");
	print("\n");

	char input;
	print("Please input a character: \n");
	input = getchar();
	print("\nThe character is: \n\n");
	putchar(input);

	print("\n");
}
#endif

